## samba 4.20.5+dfsg

=== lib/crypto/wscript ===
#!/usr/bin/env python


def build(bld):
    legacy_gnutls_helpers = ''
    if not bld.CONFIG_SET('HAVE_GNUTLS_CB_TLS_SERVER_END_POINT'):
        legacy_gnutls_helpers += ' gnutls_server_end_point_cb.c'

    bld.SAMBA_SUBSYSTEM("GNUTLS_HELPERS",
                        source='''
                        gnutls_error.c
                        gnutls_aead_aes_256_cbc_hmac_sha512.c
                        gnutls_arcfour_confounded_md5.c
                        gnutls_weak_crypto.c
                        gnutls_sp800_108.c
                        ''' + legacy_gnutls_helpers,
                        deps="gnutls samba-errors")

    bld.SAMBA_SUBSYSTEM('LIBCRYPTO',
                        source='''
                        md4.c
                        ''',
                        deps='''
                        talloc
                        ''')

    bld.SAMBA_SUBSYSTEM('TORTURE_LIBCRYPTO',
                        source='md4test.c',
                        autoproto='test_proto.h',
                        deps='''
                        LIBCRYPTO
                        ''')

    bld.SAMBA_SUBSYSTEM('gkdi',
                        source='gkdi.c',
                        deps='''
                        talloc
                        GNUTLS_HELPERS
                        NDR_GKDI
                        ''')

    bld.SAMBA_PYTHON('python_crypto',
                     source='py_crypto.c',
                     deps='gnutls talloc LIBCLI_AUTH',
                     realname='samba/crypto.so')

    bld.SAMBA_BINARY('test_gnutls_aead_aes_256_cbc_hmac_sha512',
                     source='''
                            gnutls_error.c
                            tests/test_gnutls_aead_aes_256_cbc_hmac_sha512.c
                            ''',
                     deps='cmocka gnutls samba-util samba-errors',
                     local_include=False,
                     for_selftest=True)

    bld.SAMBA_BINARY('test_gnutls_sp800_108',
                     source='''
                            tests/test_gnutls_sp800_108.c
                            ''',
                     deps='cmocka GNUTLS_HELPERS samba-util',
                     local_include=False,
                     for_selftest=True)

    bld.SAMBA_BINARY('test_gkdi_key_derivation',
                     source='test_gkdi_key_derivation.c',
                     deps='cmocka gkdi talloc NDR_GKDI samba-util samba-security',
                     for_selftest=True)

=== lib/ldb/wscript ===
#!/usr/bin/env python

APPNAME = 'ldb'
# For Samba 4.20.x !
VERSION = '2.9.1'

import sys, os

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

from wafsamba import samba_dist, samba_utils
from waflib import Errors, Options, Logs, Context
import shutil

samba_dist.DIST_DIRS('''lib/ldb:. lib/replace:lib/replace lib/talloc:lib/talloc
                        lib/tdb:lib/tdb lib/tdb:lib/tdb lib/tevent:lib/tevent
                        third_party/popt:third_party/popt
                        third_party/cmocka:third_party/cmocka
                        buildtools:buildtools third_party/waf:third_party/waf''')

samba_dist.DIST_FILES('''lib/util/binsearch.h:lib/util/binsearch.h
                         lib/util/attr.h:lib/util/attr.h''')

def options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('ldb', noextension='ldb')
    opt.RECURSE('lib/tdb')
    opt.RECURSE('lib/tevent')
    opt.RECURSE('lib/replace')
    opt.load('python') # options for disabling pyc or pyo compilation

    opt.add_option('--without-ldb-lmdb',
                   help='disable new LMDB backend for LDB',
                   action='store_true', dest='without_ldb_lmdb', default=False)


def configure(conf):
    conf.RECURSE('lib/tdb')
    conf.RECURSE('lib/tevent')

    if conf.CHECK_FOR_THIRD_PARTY():
        conf.RECURSE('third_party/popt')
        conf.RECURSE('third_party/cmocka')
    else:
        if not conf.CHECK_POPT():
            raise Errors.WafError('popt development packages have not been found.\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_POPT', 1)

        if not conf.CHECK_CMOCKA():
            raise Errors.WafError('cmocka development package have not been found.\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_CMOCKA', 1)

    conf.RECURSE('lib/replace')
    conf.find_program('xsltproc', var='XSLTPROC')
    conf.SAMBA_CHECK_PYTHON()
    conf.SAMBA_CHECK_PYTHON_HEADERS()

    # where does the default LIBDIR end up? in conf.env somewhere?
    #
    conf.CONFIG_PATH('LDB_MODULESDIR', conf.SUBST_ENV_VAR('MODULESDIR') + '/ldb')

    conf.env.standalone_ldb = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_ldb:
        max_ldb_version = [int(x) for x in VERSION.split(".")]
        max_ldb_version[2] = 999
        max_ldb_version_dots = "%d.%d.%d" % tuple(max_ldb_version)

        if conf.env.disable_python:
            if conf.CHECK_BUNDLED_SYSTEM_PKG('ldb',
                                             minversion=VERSION,
                                             maxversion=max_ldb_version_dots,
                                             onlyif='talloc tdb tevent',
                                             implied_deps='replace talloc tdb tevent'):
                conf.define('USING_SYSTEM_LDB', 1)
        else:
            using_system_pyldb_util = True
            dflt_name = 'pyldb-util' + conf.all_envs['default']['PYTHON_SO_ABI_FLAG']
            if not conf.CHECK_BUNDLED_SYSTEM_PKG(dflt_name,
                                                 minversion=VERSION,
                                                 maxversion=max_ldb_version_dots,
                                                 onlyif='talloc tdb tevent',
                                                 implied_deps='replace talloc tdb tevent ldb'):
                using_system_pyldb_util = False

            if using_system_pyldb_util:
                conf.define('USING_SYSTEM_PYLDB_UTIL', 1)

            if conf.CHECK_BUNDLED_SYSTEM_PKG('ldb',
                                             minversion=VERSION,
                                             maxversion=max_ldb_version_dots,
                                             onlyif='talloc tdb tevent %s' % dflt_name,
                                             implied_deps='replace talloc tdb tevent'):
                conf.define('USING_SYSTEM_LDB', 1)

    if not conf.CHECK_CODE('return !(sizeof(size_t) >= 8)',
                           "HAVE_64_BIT_SIZE_T_FOR_LMDB",
                           execute=True,
                           msg='Checking for a 64-bit host to '
                           'support lmdb'):
        Logs.warn("--without-ldb-lmdb implied as this "
                  "host is not 64-bit")

        if not conf.env.standalone_ldb and \
           not Options.options.without_ad_dc and \
           conf.CONFIG_GET('ENABLE_SELFTEST'):
            Logs.warn("NOTE: Some AD DC parts of selftest will fail")

        conf.env.REQUIRE_LMDB = False
    else:
        if conf.env.standalone_ldb:
            if Options.options.without_ldb_lmdb:
                conf.env.REQUIRE_LMDB = False
            else:
                conf.env.REQUIRE_LMDB = True
        elif Options.options.without_ad_dc:
            conf.env.REQUIRE_LMDB = False
        else:
            if Options.options.without_ldb_lmdb:
                if not Options.options.without_ad_dc and \
                   conf.CONFIG_GET('ENABLE_SELFTEST'):
                    raise Errors.WafError('--without-ldb-lmdb conflicts '
                                         'with --enable-selftest while '
                                         'building the AD DC')

                conf.env.REQUIRE_LMDB = False
            else:
                conf.env.REQUIRE_LMDB = True


    if conf.CONFIG_SET('USING_SYSTEM_LDB'):
        v = VERSION.split('.')
        conf.DEFINE('EXPECTED_SYSTEM_LDB_VERSION_MAJOR', int(v[0]))
        conf.DEFINE('EXPECTED_SYSTEM_LDB_VERSION_MINOR', int(v[1]))
        conf.DEFINE('EXPECTED_SYSTEM_LDB_VERSION_RELEASE', int(v[2]))

    if conf.env.standalone_ldb:
        conf.CHECK_XSLTPROC_MANPAGES()

        # we need this for the ldap backend
        if conf.CHECK_FUNCS_IN('ber_flush ldap_open ldap_initialize', 'lber ldap', headers='lber.h ldap.h'):
            conf.env.ENABLE_LDAP_BACKEND = True

        # we don't want any libraries or modules to rely on runtime
        # resolution of symbols
        if not sys.platform.startswith("openbsd"):
            conf.ADD_LDFLAGS('-Wl,-no-undefined', testflags=True)

    # if lmdb support is enabled then we require lmdb
    # is present, build the mdb back end and enable lmdb support in
    # the tools.
    if conf.env.REQUIRE_LMDB and \
       not conf.CONFIG_SET('USING_SYSTEM_LDB'):
        if not conf.CHECK_CFG(package='lmdb',
                              args='"lmdb >= 0.9.16" --cflags --libs',
                              msg='Checking for lmdb >= 0.9.16',
                              mandatory=False):
            if not conf.CHECK_CODE('''
                    #if MDB_VERSION_MAJOR == 0 \
                      && MDB_VERSION_MINOR <= 9 \
                      && MDB_VERSION_PATCH < 16
                    #error LMDB too old
                    #endif
                    ''',
                    'HAVE_GOOD_LMDB_VERSION',
                    headers='lmdb.h',
                    msg='Checking for lmdb >= 0.9.16 via header check'):

                if conf.env.standalone_ldb:
                    raise Errors.WafError('ldb build (unless --without-ldb-lmdb) '
                                         'requires '
                                         'lmdb 0.9.16 or later')
                elif not Options.options.without_ad_dc:
                    raise Errors.WafError('Samba AD DC and --enable-selftest '
                                         'requires '
                                         'lmdb 0.9.16 or later')

        if conf.CHECK_FUNCS_IN('mdb_env_create', 'lmdb', headers='lmdb.h'):
            conf.DEFINE('HAVE_LMDB', '1')
            conf.env.HAVE_LMDB = True


    conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

def build(bld):
    bld.RECURSE('lib/tevent')

    if bld.CHECK_FOR_THIRD_PARTY():
        bld.RECURSE('third_party/popt')
        bld.RECURSE('third_party/cmocka')

    bld.RECURSE('lib/replace')
    bld.RECURSE('lib/tdb')

    if bld.env.standalone_ldb:
        if not 'PACKAGE_VERSION' in bld.env:
            bld.env.PACKAGE_VERSION = VERSION
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        private_library = False
    else:
        private_library = True
    # we're not currently linking against the ldap libs, but ldb.pc.in
    # has @LDAP_LIBS@
    bld.env.LDAP_LIBS = ''

    LDB_MAP_SRC = bld.SUBDIR('ldb_map',
                             'ldb_map.c ldb_map_inbound.c ldb_map_outbound.c')

    COMMON_SRC = bld.SUBDIR('common',
                            '''ldb_modules.c ldb_ldif.c ldb_parse.c ldb_msg.c ldb_utf8.c
                            ldb_debug.c ldb_dn.c ldb_match.c ldb_options.c ldb_pack.c
                            ldb_attributes.c attrib_handlers.c ldb_controls.c qsort.c''')

    bld.SAMBA_MODULE('ldb_ldap', 'ldb_ldap/ldb_ldap.c',
                     init_function='ldb_ldap_init',
                     module_init_name='ldb_init_module',
                     deps='talloc lber ldap ldb',
                     enabled=bld.env.ENABLE_LDAP_BACKEND,
                     internal_module=False,
                     subsystem='ldb')

    if bld.PYTHON_BUILD_IS_ENABLED():
        if not bld.CONFIG_SET('USING_SYSTEM_PYLDB_UTIL'):
            name = bld.pyembed_libname('pyldb-util')
            bld.SAMBA_LIBRARY(name,
                              deps='replace ldb',
                              source='pyldb_util.c',
                              public_headers=('' if private_library else 'pyldb.h'),
                              public_headers_install=not private_library,
                              vnum=VERSION,
                              private_library=private_library,
                              pc_files='pyldb-util.pc',
                              pyembed=True,
                              enabled=bld.PYTHON_BUILD_IS_ENABLED(),
                              abi_directory='ABI',
                              abi_match='pyldb_*')

            if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
                bld.SAMBA_PYTHON('pyldb', 'pyldb.c',
                                 deps='replace ldb ' + name,
                                 realname='ldb.so',
                                 cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)

        # Do only install this file as part of the Samba build if we do not
        # use the system libldb!
        if not bld.CONFIG_SET('USING_SYSTEM_PYLDB_UTIL'):
            bld.SAMBA_SCRIPT('_ldb_text.py',
                             pattern='_ldb_text.py',
                             installdir='python')

            bld.INSTALL_FILES('${PYTHONARCHDIR}', '_ldb_text.py')

    if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
        if bld.is_install:
            modules_dir = bld.EXPAND_VARIABLES('${LDB_MODULESDIR}')
        else:
            # when we run from the source directory, we want to use
            # the current modules, not the installed ones
            modules_dir = os.path.join(os.getcwd(), 'bin/modules/ldb')

        abi_match = '!ldb_*module_ops !ldb_*backend_ops ldb_*'

        ldb_headers = ('include/ldb.h include/ldb_errors.h '
                       'include/ldb_module.h include/ldb_handlers.h')

        bld.SAMBA_LIBRARY('ldb',
                          COMMON_SRC + ' ' + LDB_MAP_SRC,
                          deps='tevent LIBLDB_MAIN replace',
                          includes='include',
                          public_headers=('' if private_library else ldb_headers),
                          public_headers_install=not private_library,
                          pc_files='ldb.pc',
                          vnum=VERSION,
                          private_library=private_library,
                          manpages='man/ldb.3',

=== debian/changelog ===
samba (2:4.20.5+dfsg-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports (resolve before-trixie build profile).

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 02 Oct 2024 09:14:52 +0300

samba (2:4.20.5+dfsg-1) unstable; urgency=medium

  * winbind: break old libpam-winbind & libnss-winbind
  * d/control: Build-Depend on python3-setuptools (#1080851)
  * d/salsa-ci.yml: disable reprotest vary build_path
  * d/gbp.con: switch to debian_4.20 branch
  * new upstream stable/bugfix release (4.20.5)

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 24 Sep 2024 07:55:33 +0300

=== debian/control ===
Source: samba
Section: net
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>,
           Jelmer Vernooĳ <jelmer@debian.org>,
           Mathieu Parent <sathieu@debian.org>,
           Michael Tokarev <mjt@tls.msk.ru>
Homepage: https://www.samba.org
Standards-Version: 4.7.0
Build-Depends:
	debhelper-compat (= 13),
	dh-exec,
Build-Depends-Arch:
	dh-sequence-python3,
        python3-setuptools,
	dpkg-dev (<< 1.22.5),
# tools:
	bison,
	docbook-xml, docbook-xsl, xsltproc,
	flex,
	perl:any,
	po-debconf,
# libraries which we embed but use system versions of:
	libtalloc-dev (>= 2.4.2~),
	python3-talloc-dev (>= 2.4.2~),
	libtevent-dev (>= 0.16.1~),
	libtdb-dev (>= 1.4.10~),
	python3-tdb (>= 1.4.10~),
# system libraries:
	pkgconf,
	libacl1-dev,
	libarchive-dev,
	libavahi-client-dev,
	libavahi-common-dev,
	libblkid-dev,
	libbsd-dev,
	libcap-dev [linux-any],
# the same [arch list] is in ctdb.install
	libcephfs-dev [amd64 arm64 mips64el ppc64el riscv64 s390x],
	librados-dev  [amd64 arm64 mips64el ppc64el riscv64 s390x],
	libcmocka-dev,
	libcups2-dev,
	libdbus-1-dev,
	libglusterfs-dev [amd64 arm64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
	libgnutls28-dev,
	libgpgme11-dev,
	libicu-dev,
	libjansson-dev,
	libkeyutils-dev [linux-any],
	libkrb5-dev (>= 1.21.0~) <pkg.samba.mitkrb5>,
	libldap2-dev,
	liblmdb-dev,
	libpam0g-dev,
	libparse-yapp-perl,
	libpcap-dev [hurd-i386 kfreebsd-any],
	libpopt-dev,
	libreadline-dev,
	libtirpc-dev,
	libsystemd-dev [linux-any],
	libtasn1-6-dev,
	libtasn1-bin,
	liburing-dev [linux-any],
	xfslibs-dev [linux-any],
	zlib1g-dev,
# python (+#904999):
	python3-dev:any | python3-dev, libpython3-dev,
	python3-dnspython,
	python3-etcd,
	python3-markdown,
# dependencies needed for selftest:
#	python3-testtools <!nocheck>,
#	lmdb-utils <!nocheck>,
#	openssl <!nocheck>,
#	python3-cryptography <!nocheck>,
#	python3-iso8601 <!nocheck>,
#	python3-pyasn1 <!nocheck>,
#	tdb-tools <!nocheck>,
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/samba-team/samba
Vcs-Git: https://salsa.debian.org/samba-team/samba.git

Package: samba
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: passwd,
         procps,
         samba-common (= ${source:Version}),
         samba-common-bin (=${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: attr,
            python3-samba,
Suggests: ctdb,
          ufw,
          winbind,
          samba-vfs-ceph, samba-vfs-glusterfs,
# move libdfs-server-ad-samba4.so.0 samba-libs=>samba-vfs-modules in 4.19.0~rc1
# swallow samba-vfs-modules by samba in 4.20.2-dfsg-3
Replaces: samba-libs (<< 2:4.19.0~),
          samba-vfs-modules (<< 2:4.20.2+dfsg-3~),
Breaks:   samba-ad-provision (<< ${source:Upstream-Version}),
          samba-libs (<< 2:4.19.0~),
          samba-vfs-modules (<< 2:4.20.2+dfsg-3~),
          samba-ad-dc (<< 2:4.20.1+dfsg-2~),
Description: SMB/CIFS file, print, and login server for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.  Samba can also function
 as an Active Directory or NT4-style domain controller, and can integrate
 with Active Directory realms or NT4 domains as a member server.
 .
 This package provides the components necessary to use Samba as a stand-alone
 file and print server or as an NT4 domain controller.  For use in an NT4
 domain or Active Directory realm, you will also need the winbind package.
 To use samba as an Active Directory domain controller (AD DC), please install
 samba-ad-dc package.
 .
 This package is not required for connecting to existing SMB/CIFS servers
 (see smbclient) or for mounting remote filesystems (see cifs-utils).

Package: samba-libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Provides: libndr4 (= ${binary:Version}), libsmbldap2 (= ${binary:Version})
Depends: ${misc:Depends}, ${shlibs:Depends},
# since libldb ABI is incorrectly versioned resulting in breakage like #1021371,
# just require libldb version of the same build
# https://lists.samba.org/archive/samba-technical/2023-September/138422.html
 libldb2 (= ${ldb:Version}),
Replaces:
# libsamba-util.so &deps moved from libwbclient0 to samba-libs in 4.16.1+dfsg-7
 libwbclient0 (<< 2:4.16.1+dfsg-7~),
# libpac-samba4.so.0 moved from samba to samba-libs in 4.17.0+dfsg-2
 samba (<< 2:4.17.0+dfsg-2~),
Breaks:
 libwbclient0 (<< 2:4.16.1+dfsg-7~),
 samba (<< 2:4.17.0+dfsg-2~),
 sssd-ad (<< 2.9.4-1+b1),
 sssd-ad-common (<< 2.9.4-1+b1),
 sssd-ipa (<< 2.9.4-1+b1),
Description: Samba core libraries
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains the shared libraries.

Package: samba-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ucf, ${misc:Depends}
Recommends: samba-common-bin
Description: common files used by both the Samba server and client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains common files used by all parts of Samba.

Package: samba-common-bin
Architecture: any
Depends: samba-common (= ${source:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-samba,
Suggests: heimdal-clients,
# moved libnet-keytab-samba4.so.0 & libRPC-WORKER-samba4.so.0 samba-libs=>samba-common-bin in 4.19.0~r1
# moved smbcontrol samba=>samba-common-bin in 4.20.0-2
Replaces: samba (<< 2:4.20.1+dfsg-2~), samba-libs (<< 2:4.19.0~)
Breaks:   samba (<< 2:4.20.1+dfsg-2~), samba-libs (<< 2:4.19.0~)
Description: Samba common files used by both the server and the client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the smbclient
 package).

Package: samba-ad-dc
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: samba (= ${binary:Version}),
	 python3-samba (= ${binary:Version}),
	 python3-dnspython,
	 samba-dsdb-modules (= ${binary:Version}),
	 winbind (= ${binary:Version}),
	 krb5-kdc (>= 1.21.0~) <pkg.samba.mitkrb5>,
	 ${python3:Depends},
	 ${shlibs:Depends},
	 ${misc:Depends}
Recommends: libnss-winbind, libpam-winbind,
# samba-ad-provision is needed for setup only
	samba-ad-provision
Suggests: bind9,
	  bind9utils,
	  ldb-tools,
	  ntp | chrony,
Enhances: bind9, ntp
Breaks:   samba-ad-provision (<< ${source:Upstream-Version}),
# files moved from samba & samba-common-bin in 4.20.1-2:
	  samba-common-bin (<< 2:4.20.1+dfsg-2~),
Replaces: samba-common-bin (<< 2:4.20.1+dfsg-2~),
# Breaks+Replaces upgraded to Conflicts for DEP17 + /usr-move
Conflicts: samba (<< 2:4.20.1+dfsg-2~),
Description: Samba control files to run AD Domain Controller
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains control files to run an Active Directory Domain
 Controller (AD DC).  For now, this is just a metapackage pulling in
 all the required dependencies.

Package: samba-ad-provision
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 python3-markdown,
Replaces: samba (<< 2:4.17.3+dfsg-4~)
Breaks:   samba (<< 2:4.17.3+dfsg-4~)
Description: Samba files needed for AD domain provision
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains files to setup an Active Directory Domain
 Controller (AD DC).

Package: smbclient
Architecture: any
Depends: samba-common (= ${source:Version}),
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: samba-client
Suggests: cifs-utils, heimdal-clients
Description: command-line SMB/CIFS clients for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains command-line utilities for accessing Microsoft
 Windows and Samba servers, including smbclient, smbtar, and smbspool.
 Utilities for mounting shares locally are found in the package
 cifs-utils.

Package: samba-testsuite
Architecture: any
Suggests: subunit
Depends: samba-common-bin,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
# move libshares-samba4.so.0 samba-libs=>samba-testsuite in 4.19.0~rc1
Replaces: samba-libs (<< 2:4.19.0~)
Breaks:   samba-libs (<< 2:4.19.0~)
Description: test suite from Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: samba-libs (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: tools for viewing and manipulating the Windows registry
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: samba-dev
Architecture: any
Multi-Arch: same
Depends: libc6-dev,
         libldb-dev,
         libpopt-dev,
         libtalloc-dev,
         libtdb-dev,
         libtevent-dev,
         libwbclient-dev,
         samba-libs (= ${binary:Version}),
         ${misc:Depends}
# libsamba-util.so moved from libwbclient0 to samba-libs in 4.16.1+dfsg-7
Replaces: libwbclient-dev (<< 2:4.16.1+dfsg-7~)
Breaks:   libwbclient-dev (<< 2:4.16.1+dfsg-7~)
Section: devel
Description: tools for extending Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains include files shared by the various Samba-based
 libraries.

Package: python3-samba
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Section: python
Depends: python3-ldb (= ${ldb:Version}),
         samba-libs (= ${binary:Version}),
         python3-tdb,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Breaks:
# samba-tool & samba-gpupdate moved from samba-common-bin & samba in 4.20.1-2:
          samba-common-bin (<< 2:4.20.1+dfsg-2~), samba (<< 2:4.20.1+dfsg-2~),
Replaces:
	  samba-common-bin (<< 2:4.20.1+dfsg-2~), samba (<< 2:4.20.1+dfsg-2~),

## samba 4.21.0~rc1+really4.20.2+dfsg

=== debian/changelog ===
samba (2:4.21.0~rc1+really4.20.2+dfsg-11.1.0nosystemd) nosystemd; urgency=medium

  * No systemd/elogind

 -- anticapitalista <antix@operamail.com>  Wed, 31 Jul 2024 16:08:40 +0300

samba (2:4.21.0~rc1+really4.20.2+dfsg-11) unstable; urgency=medium

  * bump upstream version to 4.21.0~rc1+really4.20.2+dfsg to cancel
    mistaken upload of 4.21.0~rc1 to unstable instead of experimental

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 30 Jul 2024 15:56:11 +0300

=== debian/control ===
--- 
+++ 
@@ -13,14 +13,14 @@
 	dh-exec,
 Build-Depends-Arch:
 	dh-sequence-python3,
-        python3-setuptools,
-	dpkg-dev (<< 1.22.5),
+	dpkg-dev (>= 1.22.5) <!pkg.samba.before-trixie>,
 # tools:
 	bison,
 	docbook-xml, docbook-xsl, xsltproc,
 	flex,
 	perl:any,
 	po-debconf,
+	rpcsvc-proto  <!pkg.samba.before-trixie>,
 # libraries which we embed but use system versions of:
 	libtalloc-dev (>= 2.4.2~),
 	python3-talloc-dev (>= 2.4.2~),
@@ -57,7 +57,6 @@
 	libpopt-dev,
 	libreadline-dev,
 	libtirpc-dev,
-	libsystemd-dev [linux-any],
 	libtasn1-6-dev,
 	libtasn1-bin,
 	liburing-dev [linux-any],

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

# Fast version of dpkg/architecture.mk defining all vars in one go
ifeq (${DEB_HOST_MULTIARCH},)
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# build is done in bin/default/ subdir
DEB_CFLAGS_MAINT_APPEND = -ffile-prefix-map=../../=

ifneq (,$(filter armel mipsel m68k powerpc sh4,${DEB_HOST_ARCH}))
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=81358
# on these platforms gcc does not link with -latomic, resulting in
#   third_party/heimdal/lib/krb5/krcache.c.55.o: in function `krcc_get_principal':
#   third_party/heimdal/lib/krb5/krcache.c:1395: undefined reference to `__atomic_load_8'
#     ids.krcu_cache_and_princ_id = heim_base_atomic_load(&data->krc_cache_and_principal_id);
#   third_party/heimdal/lib/base/heimbase-atomics.h:
#     #include <stdatomic.h>
#     #define heim_base_atomic_load(x)        atomic_load((x))
# include a workaround for now
# (-latomic and <stdatomic.h> comes from gcc, --as-needed is already in use)
DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

ifneq (,$(filter m68k ,${DEB_HOST_ARCH}))
# without this, build fails with multiple messages like:
# foo.s:NNN: Error: Adjusted signed .word (0xb64a) overflows: `switch'-statement too large.
# when building third_party/heimdal/lib/asn1/asn1_rfc2459_asn1.c (generated)
# It would be best to enable this switch for a single file only (where it is needed)
DEB_CFLAGS_MAINT_APPEND += -mlong-jump-table-offsets
endif

include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
V := $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)
WAF := PYTHONHASHSEED=1 ./buildtools/bin/waf \
	$(patsubst parallel=%,-j%,$(filter parallel=%,${DEB_BUILD_OPTIONS}))

# stop python from generating .pyc caches
export PYTHONDONTWRITEBYTECODE=1

ifeq (linux,${DEB_HOST_ARCH_OS})
ifneq (${DEB_HOST_GNU_TYPE},${DEB_BUILD_GNU_TYPE})
# for cross-build or build with foreign python binary (it is _gnu0_i386-gnu on hurd)
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__${DEB_HOST_ARCH_OS}_${DEB_HOST_MULTIARCH}
endif
endif

DESTDIR = ${CURDIR}/debian/tmp

# used to be dpkg_late_eval
late-eval = $(or $(value cache-$1),$(eval cache-$1 := $(shell $2))$(value cache-$1))

LDB_VERSION = $(call late-eval,LDB_VERSION,grep ^VERSION lib/ldb/wscript | cut -d\' -f2)
LDB_DEB_VERSION = 2:${LDB_VERSION}+samba${DEB_VERSION_UPSTREAM_REVISION}
LDB_PACKAGES = libldb2 libldb-dev ldb-tools python3-ldb

before-trixie := $(filter pkg.samba.before-trixie, ${DEB_BUILD_PROFILES})

omit-pkgs =

config-args = \
	--vendor-name=${DEB_VENDOR}-${DEB_VERSION_UPSTREAM_REVISION} \
	--prefix=/usr \
	--enable-fhs \
	--sysconfdir=/etc \
	--localstatedir=/var \
	--libexecdir=/usr/libexec \
	--libdir=/usr/lib/${DEB_HOST_MULTIARCH} \
	--datadir=/usr/share \
	--with-modulesdir=/usr/lib/${DEB_HOST_MULTIARCH}/samba \
	--with-pammodulesdir=/lib/${DEB_HOST_MULTIARCH}/security \
	--with-privatedir=/var/lib/samba/private \
	--with-smbpasswd-file=/etc/samba/smbpasswd \
	--with-piddir=/run/samba \
	--with-lockdir=/run/samba \
	--with-sockets-dir=/run/samba \
	--with-statedir=/var/lib/samba \
	--with-cachedir=/var/cache/samba \
	--with-pam \
	--with-syslog \
	--with-utmp \
	--with-winbind \
	--with-automount \
	--with-ldap \
	--with-ads \
	--with-gpgme \
	--enable-avahi \
	--enable-spotlight \
	--with-profiling-data \
	--disable-rpath --disable-rpath-install \
	--bundled-libraries=NONE,pytevent,ldb \
	\
	--with-cluster-support \
	--enable-etcd-reclock \
	--with-socketpath=/run/ctdb/ctdbd.socket \
	--with-logdir=/var/log/ctdb \

# some modules are linked statically by default (see default_static_module in wscript*),
# but they're often linked into other libraries, which might result in cyclic deps.
# Eg, vfs_dfs_samba4 is statically linked to libsmbd-base-private, which is part of
# samba-libs (not samba), because it is used by python3-samba too (smbd.cpython).
# Might consider using --with-shared-modules=ALL
# Other modules (vfs_nfs4acl_xattr) are not enabled by default (#930540).
config-args += \
	--with-shared-modules=vfs_dfs_samba4,vfs_nfs4acl_xattr,auth_samba4

ifeq (${DEB_HOST_ARCH_OS}, linux) # extra linux-specific features

config-args += \
	--with-quota \
	\

endif

# Ubuntu i386 binary compatibility only effort: Disable some i386 packages and modules
ifeq (${DEB_VENDOR}-${DEB_HOST_ARCH}, Ubuntu-i386)
omit-pkgs += ctdb libpam-winbind samba samba-ad-dc samba-testsuite samba-vfs-modules samba-vfs-ceph samba-vfs-glusterfs
endif

# we had t64 transition (libsmbclient => libsmbclient0) for trixie
libsmbclient := $(if ${before-trixie},libsmbclient,libsmbclient0)

mitkrb5-dep-pkgs :=
ifneq (,$(filter pkg.samba.mitkrb5, ${DEB_BUILD_PROFILES}))
config-args += \
	--with-system-mitkrb5 \
	--with-experimental-mit-ad-dc \
	--with-system-mitkdc=/usr/sbin/krb5kdc
# samba packages will have its own version suffix
mitkrb5-samba-ver = ${DEB_VERSION}mitkrb5
mitkrb5-dep-pkgs += samba-libs samba-dev
mitkrb5-dep-pkgs += samba samba-common-bin python3-samba
mitkrb5-dep-pkgs += samba-vfs-ceph samba-vfs-glusterfs
mitkrb5-dep-pkgs += samba-dsdb-modules
mitkrb5-dep-pkgs += ${libsmbclient} smbclient
mitkrb5-dep-pkgs += libnss-winbind libpam-winbind
mitkrb5-dep-pkgs += winbind libwbclient0
mitkrb5-dep-pkgs += samba-testsuite
mitkrb5-dep-pkgs += ctdb
endif

ifneq (,${omit-pkgs})
export DH_OPTIONS += $(addprefix -N, ${omit-pkgs})
endif
# ${build-pkgs} will honour arch/indep and the above list in ${DH_OPTIONS}
build-pkgs := $(shell dh_listpackages)

with-ceph := $(filter samba-vfs-ceph,${build-pkgs})
config-args += $(if ${with-ceph},\
	  --enable-cephfs --enable-ceph-reclock,\
	  --disable-cephfs)

binary binary-arch binary-indep \
install install-arch install-indep: %:
	dh $*

configure: bin/configured.stamp
.PHONY: configure
bin/configured.stamp:
	CC="${CC}" CPP="${CPP}" LD="${LD}" PKGCONFIG="${PKG_CONFIG}" \
	CPPFLAGS="${CPPFLAGS}" CFLAGS="${CFLAGS}" LDFLAGS="${LDFLAGS}" \
	PYTHON=python3 PYTHON_CONFIG=${DEB_HOST_MULTIARCH}-python3-config \
	    ${WAF} -j1 -C configure ${config-args} || \
	  { $(if ${V},echo "==== contents of config.log:"; cat bin/config.log;) false; }
# #1013205: https://lists.samba.org/archive/samba-technical/2022-November/137788.html
	rm -f third_party/heimdal/lib/gssapi/gssapi.h
	touch $@

build-arch: bin/built.stamp
bin/built.stamp: bin/configured.stamp
# samba build system is designed so that default build (what is produced
# by waf build) supposed to be run directly from the build directory,
# with all the paths pointing there.  At the install stage, quite some
# recompilation/relinking is done again, to adopt to the actual install
# paths. There's no need (for now) to build samba to be run from the build
# directory, so we use `waf install' here instead of `waf build'.
# Build these two executables first, and build the install stage.
# This will pefrorm unnecessary/extra install step (into d/tmp), which
# we'll repeat during actual install stage, but this is definitely
# better/faster than building whole thing for _not_ running from the build dir.
	${WAF} $(if $V,-v) install --destdir="${DESTDIR}"
	touch $@
build-indep:
build: build-arch build-indep

##############  Tests ##############
# We should use separate build for tests since it requires configuration
# with --enable-selftest which is not compatible with production build.
# Since samba build system always builds in bin/, we save whole source
# into a subdir (testbuild/) and run everything from there.

testbuild/copied.stamp:
	rm -rf testbuild; mkdir testbuild
	cp -a -l $$(ls -1 | egrep -v '^(bin|testbuild|debian)$$') testbuild/
# cleanup some files just in case, do not interfere with production build
	find testbuild -name __pycache__ -exec rm -rf {} +
	rm -f testbuild/compile_commands.json
	touch $@
testbuild/configured.stamp: testbuild/copied.stamp
	@echo "############## selftest configure ##############"

## samba 4.21.0~rc1+really4.20.4+dfsg

=== debian/changelog ===
samba (2:4.21.0~rc1+really4.20.4+dfsg-1) unstable; urgency=medium

  * prefix upstream version with 4.21.0~rc1+really to cancel work around
    mistaken upload of 4.21.0~rc1 to unstable instead of experimental

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 06 Aug 2024 17:00:57 +0300

=== debian/control ===
--- 
+++ 
@@ -57,6 +57,7 @@
 	libpopt-dev,
 	libreadline-dev,
 	libtirpc-dev,
+	libsystemd-dev [linux-any],
 	libtasn1-6-dev,
 	libtasn1-bin,
 	liburing-dev [linux-any],

=== debian/rules ===
--- 
+++ 
@@ -57,7 +57,8 @@
 late-eval = $(or $(value cache-$1),$(eval cache-$1 := $(shell $2))$(value cache-$1))
 
 LDB_VERSION = $(call late-eval,LDB_VERSION,grep ^VERSION lib/ldb/wscript | cut -d\' -f2)
-LDB_DEB_VERSION = 2:${LDB_VERSION}+samba${DEB_VERSION_UPSTREAM_REVISION}
+# +really: #1077749
+LDB_DEB_VERSION = 2:2.10.0+samba4.21.0~rc1+really${LDB_VERSION}+samba$(lastword $(subst +really, ,${DEB_VERSION_UPSTREAM_REVISION}))
 LDB_PACKAGES = libldb2 libldb-dev ldb-tools python3-ldb
 
 before-trixie := $(filter pkg.samba.before-trixie, ${DEB_BUILD_PROFILES})
@@ -65,7 +66,7 @@
 omit-pkgs =
 
 config-args = \
-	--vendor-name=${DEB_VENDOR}-${DEB_VERSION_UPSTREAM_REVISION} \
+	--vendor-suffix=${DEB_VENDOR}-${DEB_VERSION_UPSTREAM_REVISION} \
 	--prefix=/usr \
 	--enable-fhs \
 	--sysconfdir=/etc \
@@ -114,7 +115,7 @@
 
 config-args += \
 	--with-quota \
-	\
+	--with-systemd \
 
 endif
 
@@ -202,5 +203,3 @@
 	find testbuild -name __pycache__ -exec rm -rf {} +
 	rm -f testbuild/compile_commands.json
 	touch $@
-testbuild/configured.stamp: testbuild/copied.stamp
-	@echo "############## selftest configure ##############"

## samba 4.21.0+dfsg

=== debian/changelog ===
samba (2:4.21.0+dfsg-1) unstable; urgency=medium

  * switch to 4.21 branch
  * update to 4.21.0 (new upstream)
  * fix-nfs-service-name-to-nfs-kernel-server.patch: refresh
  * Force-LDB-as-standalone.patch: remove (ldb is always internal now)
  * d/rules: ldb lib is now private by default, expose it as public
  * d/rules: ldb uses LDB_VERSION variable now, not VERSION
  * tilde-in-version.diff: remove (applied upstream)
  * heimdal-spelling.patch: disable for now
  * d/rules: s/vendor-name/vendor-suffix/
  * d/ctdb.install: no more sudoers file
  * d/samba-libs.symbols, d/control, d/samba-libs.install: libndr4=>libndr5
    This requires sssd to be rebuilt
  * samba-{libs,dev}.install, python3-{samba,ldb).install: refresh libs
    (with lintian-overrides)
  * samba-libs.install, samba-dev.install: new (semi-public) library:
    libsamba-policy.so (used by the python stuff only, for now)
  * samba-libs.install: new private library: libsamba-net-private-samba.so.0
  * libldb2.symbols: add new symbols & 2.10.0 version
    (and remove 2.9.1 minor version)
  * d/control: bump libtdb version dependency to 1.4.12
  * d/ctdb.install: install winbind_ctdb_updatekeytab.sh file

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 02 Sep 2024 17:48:34 +0300

=== debian/control ===
--- 
+++ 
@@ -25,8 +25,8 @@
 	libtalloc-dev (>= 2.4.2~),
 	python3-talloc-dev (>= 2.4.2~),
 	libtevent-dev (>= 0.16.1~),
-	libtdb-dev (>= 1.4.10~),
-	python3-tdb (>= 1.4.10~),
+	libtdb-dev (>= 1.4.12~),
+	python3-tdb (>= 1.4.12~),
 # system libraries:
 	pkgconf,
 	libacl1-dev,
@@ -125,7 +125,7 @@
 Multi-Arch: same
 Architecture: any
 Section: libs
-Provides: libndr4 (= ${binary:Version}), libsmbldap2 (= ${binary:Version})
+Provides: libndr5 (= ${binary:Version}), libsmbldap2 (= ${binary:Version})
 Depends: ${misc:Depends}, ${shlibs:Depends},
 # since libldb ABI is incorrectly versioned resulting in breakage like #1021371,
 # just require libldb version of the same build

=== debian/rules ===
--- 
+++ 
@@ -56,9 +56,8 @@
 # used to be dpkg_late_eval
 late-eval = $(or $(value cache-$1),$(eval cache-$1 := $(shell $2))$(value cache-$1))
 
-LDB_VERSION = $(call late-eval,LDB_VERSION,grep ^VERSION lib/ldb/wscript | cut -d\' -f2)
-# +really: #1077749
-LDB_DEB_VERSION = 2:2.10.0+samba4.21.0~rc1+really${LDB_VERSION}+samba$(lastword $(subst +really, ,${DEB_VERSION_UPSTREAM_REVISION}))
+LDB_VERSION = $(call late-eval,LDB_VERSION,grep ^LDB_VERSION lib/ldb/wscript | cut -d\' -f2)
+LDB_DEB_VERSION = 2:${LDB_VERSION}+samba${DEB_VERSION_UPSTREAM_REVISION}
 LDB_PACKAGES = libldb2 libldb-dev ldb-tools python3-ldb
 
 before-trixie := $(filter pkg.samba.before-trixie, ${DEB_BUILD_PROFILES})
@@ -95,7 +94,8 @@
 	--enable-spotlight \
 	--with-profiling-data \
 	--disable-rpath --disable-rpath-install \
-	--bundled-libraries=NONE,pytevent,ldb \
+	--bundled-libraries=NONE,pytevent \
+	--private-libraries=!ldb \
 	\
 	--with-cluster-support \
 	--enable-etcd-reclock \
@@ -203,3 +203,4 @@
 	find testbuild -name __pycache__ -exec rm -rf {} +
 	rm -f testbuild/compile_commands.json
 	touch $@
+testbuild/configured.stamp: testbuild/copied.stamp
